echo off/m

{microSQL procedure to illustrate screen-based updating}

set display off
set upshift on

{Define the update menu}

case

draw pmupd +pmmenu
send @24,19

{Accept the required option}

accept

{Define the screen for displaying and updating pm data}

screen 1

draw pmupd +pmcols
send @25,1/green,b  <F1> for help
send @25,55/green,b  <Esc> to exit update

{Accept the required pm name}

enter into %pm_name @11,40/12/cy,b;
send @25,1/green,b

{Check that data for exactly one pm will be retrieved}

select count(*)
from   prime_minister
where  pm_name like '&pm_name%';

assign into %pm_count 0
fetch fields
fetch into %pm_count

{Display message if name not ok}

if &pm_count = 0
  send /red,b
  pause /3  Cannot find this pm
else
  if &pm_count > 1
    send /red,b
    pause /3  This pm name is not unique
  else

    {Ok to proceed - retrieve data for pm}

    select *
    from   prime_minister
    where  pm_name like '&pm_name%';

    {Initialise cursor, redisplay pm name and space over <esc> message}

    fetch fields
    fetch into %pm_name
    send @11,40/yellow,b/high &pm_name
    space @25,55/yellow/off,b/high 25

    {Display existing field values}

    send /blue,b
    fetch into %birth_yr @16,17
    fetch into %yrs_served @16,42
    fetch into %death_age @16,65
    fetch into %state_born @19,17
    fetch into %state_rep @19,73

    {Get values for update}

    enter into %birth_yr @16,17 /4/d1930,1960/cb,b;
    enter into %yrs_served @16,42 /5/d0,20/cb,b;
    enter into %death_age @16,65 /2/d20,100/cb,b;
    enter into %state_born @19,17 /3/u/cb,b;
    enter into %state_rep @19,73 /3/u/cb,b;

    {Update pm table}

    update prime_minister
    set    birth_yr = &birth_yr,
           yrs_served = &yrs_served,
           death_age = &death_age,
           state_born = '&state_born',
           state_rep = '&state_rep'
    where  pm_name = '&pm_name';

  endif
endif

{Define help panel}

panel

send @22,1/green,b  Enter the name of a  prime  minister
send @+1,1  and existing data will be displayed.
send @+1,1  Type each new value or press <enter>
pause @+1,1  to skip. Press a key to continue ...
send /yellow/off,b/high
space block 22,1 25,38
send @25,1/green,b/high  <F1> for help
space /yellow,b 0

{Define marriage screen}

screen 2

{Not implemented}

call 5
return

{Define recreation screen}

screen 3

{Not implemented}

call 5
return

{Define ministry screen}

screen 4

{Not implemented}

call 5
return

{Define deputy pm screen}

screen 5

{Not implemented}

send @24,1 /red,b  This option is not implemented
pause /3
return

{Define the exit screen}

screen 6

{Tidy up and return to calling procedure}

send @24,1/green,b  Loading main program ...
set display on
set upshift off
send /normal
