Program Uppercase;
Const
  maxparms = 10; {Maximum number of SQL parameters handled by program}
  parmlen = 40;  {Maximum length of each SQL parameters value in bytes}
  msglen = 30;   {Maximum length of an error message}
Type
  parmstr = string[parmlen];
  parmptr = ^parmstr;
  parmarray = array[1..maxparms] of parmptr;
  msgstr = string[msglen];
Var
  nrparms : word;
  parms : parmarray; {Pointers to the SQL parameters}

Procedure terminate(msg : msgstr); {Halts execution if error
                                    condition arises}
Begin
  writeln(msg);
  halt;
end; {terminate}

Procedure set_ptr_addresses; {Get the segment and offset addresses
                              of parameters from command line}
Var
  segm, offs, error1, error2, parmnr : word;
Begin
  val(paramstr(1),nrparms,error1);
  if error1 <> 0 then
    terminate('Invalid number of parameters');
  for parmnr:=1 to nrparms do
    begin
      val(paramstr(2*parmnr),segm,error1);
      val(paramstr(2*parmnr+1),offs,error2);
      if (error1 <> 0) or (error2 <> 0) then
        terminate('Invalid address');
      parms[parmnr]:=ptr(segm,offs);
    end;
end; {set_ptr_addresses}

Procedure process_parameters; {Change all letters in the parameter
                               strings to upper case}
Var parmnr, chnr : word;
Begin
  for parmnr:=1 to nrparms do
    for chnr:=1 to length(parms[parmnr]^) do
      parms[parmnr]^[chnr]:=upcase(parms[parmnr]^[chnr]);
end; {process_parameters}

Begin {Uppercase}
  set_ptr_addresses;
  process_parameters;
end.